unit formPropEq;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Math,
  Dialogs, Menus, StdCtrls, CheckLst, ExtCtrls, BaseClass, ComCtrls, Buttons,
  CommCtrl, Registry, ImgList, DCBassSourceIntf, BassDecoder, DirectSound,
  Themes, ActnList;

const
  CLSID_DCBASS_PropertyPageEq: TGuid = '{70FA3BB9-BCD2-4b36-90BE-B05430271C42}';

type
  TfrmPropEq = class(TFormPropertyPage)
    chkEnabled: TCheckBox;
    GroupBox3: TGroupBox;
    l3: TLabel;
    l4: TLabel;
    l5: TLabel;
    l6: TLabel;
    l7: TLabel;
    l8: TLabel;
    l9: TLabel;
    l10: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    l1: TLabel;
    l2: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    s3: TTrackBar;
    s4: TTrackBar;
    s5: TTrackBar;
    s6: TTrackBar;
    s7: TTrackBar;
    s8: TTrackBar;
    s9: TTrackBar;
    s10: TTrackBar;
    s1: TTrackBar;
    s2: TTrackBar;
    Button1: TButton;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure chkEnabledClick(Sender: TObject);
    procedure EQChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure WMEraseBkGnd(var Message: TWMEraseBkGnd); message WM_ERASEBKGND;
  private
    FIntf: IDCBassSourceEx;
    FCanChange: Boolean;
    procedure UpdateLabel(Index: integer; Value: Single);
    procedure UpdateValues(UpdateCombo: Boolean);
  public
    function OnConnect(Unknown: IUnknown): HRESULT; override;
    function OnDisconnect: HRESULT; override;
  end;

implementation

{$R *.DFM}

procedure UpdateTrackbars(Form: TForm);
var
  i: integer;
begin
  for i := 0 to Form.ComponentCount -1 do
    if (Form.Components[i].InheritsFrom(TTrackBar)) then
      SetWindowLong(TTrackBar(Form.Components[i]).Handle, GWL_STYLE,
                    GetWindowLong(TTrackBar(Form.Components[i]).Handle,
                                  GWL_STYLE) and not TBS_ENABLESELRANGE);
end;

function TfrmPropEq.OnConnect(Unknown: IUnKnown): HRESULT;
begin
  Unknown.QueryInterface(IID_IDCBassSourceEx, fIntf);
  Result := S_OK;
end;

function TfrmPropEq.OnDisconnect: HRESULT;
begin
  fIntf := nil;
  Result := S_OK;
end;

procedure TfrmPropEq.Timer1Timer(Sender: TObject);
var
  B: LongBool;
  E: Boolean;
  I: Integer;
begin
  E:=Assigned(FIntf) and (FIntf.GetEqEnabled(B) = S_OK);
  chkEnabled.Enabled:=E;
  Button1.Enabled:=E;
  for I := 0 to GroupBox3.ControlCount - 1 do
    GroupBox3.Controls[I].Enabled:=E;
end;

procedure TfrmPropEq.WMEraseBkGnd(var Message: TWMEraseBkGnd);
var
  Details: TThemedElementDetails;
begin
  if not ThemeServices.ThemesEnabled then
    inherited
  else begin
    Details:=ThemeServices.GetElementDetails(ttBody);
    ThemeServices.DrawElement(Message.DC,Details,ClientRect);
  end;
end;

procedure TfrmPropEq.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled:=False;
end;

procedure TfrmPropEq.FormShow(Sender: TObject);
begin
  UpdateValues(True);
  UpdateTrackbars(Self);
  Timer1Timer(Timer1);
  Timer1.Enabled:=True;
end;

procedure TfrmPropEq.chkEnabledClick(Sender: TObject);
begin
  if Assigned(fIntf) then
    fIntf.setEqEnabled(chkEnabled.Checked);
end;

procedure TfrmPropEq.EQChange(Sender: TObject);
var
  tb: TTrackBar;
  p: Single;
begin
  if not fCanChange then Exit;
  tb := Sender as TTrackBar;
  p := 0 - (tb.Position / 10);
  UpdateLabel(tb.Tag,p);
  if Assigned(fIntf) then
    fIntf.SetEqBandGain(tb.Tag-1,p);
end;

procedure TfrmPropEq.UpdateLabel(Index: integer; Value: Single);
var
  l: TLabel;
begin
  l  := FindComponent('l' + inttostr(Index)) as TLabel;
  l.Caption := Format('%.1f', [Value]);
end;

procedure TfrmPropEq.UpdateValues(UpdateCombo: Boolean);
var
  b: LongBool;
  p: Single;
  i: integer;
  tb: TTrackBar;
begin
  fCanChange := False;

  if Assigned(fIntf) then begin
    fIntf.GetEqEnabled(b);
    chkEnabled.Checked := b;
    for i := 0 to BASS_EQ_BAND_NUM -1 do
    begin
      fIntf.GetEqBandGain(i,p);
      tb := FindComponent('s' + inttostr(i+1)) as TTrackBar;
      tb.Position := 0 - Round(p * 10);
      UpdateLabel(i+1, p);
    end;
  end;

  fCanChange := True;
end;

procedure TfrmPropEq.Button1Click(Sender: TObject);
var
  i: integer;
  tb: TTrackBar;
  ma, mi: integer;
begin
  ma := s1.Max;
  mi := s1.Min;

  mi := EnsureRange(0, mi, ma);

  for i := 0 to BASS_EQ_BAND_NUM -1 do
  begin
    tb := FindComponent('s' + inttostr(i+1)) as TTrackBar;
    tb.Position := mi;
    EQChange(tb);
  end;
end;

initialization

  TBCClassFactory.CreatePropertyPage(TfrmPropEq, CLSID_DCBASS_PropertyPageEq);

end.
